:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_17646,_17640/_17642,_17650):-(retract(dynamicVersion(_17646,_17640/_17642,_17664))->true;true),asserta(dynamicVersion(_17646,_17640/_17642,_17650)).
prim_assertFact('Dynamic.Dynamic'(_17758),'Prelude.()'):-retract(dynamicTime(_17768)),_17782 is _17768+1,assertz(dynamicTime(_17782)),_17758=..[_17796,_17802,_17808,_17814|_17816],_17844=..[_17796,_17782,0|_17816],assertz(user:_17844),logDynamicEvent(_17802,assertz,_17844).
prim_retractFact('Dynamic.Dynamic'(_17946),_17952):-_17946=..[_17956,_17962,_17968,_17974|_17976],_18004=..[_17956,_17992,_17998|_17976],reloadNewestDynamicVersionOf(_17956),retract(dynamicTime(_18014)),_18028 is _18014+1,assertz(dynamicTime(_18028)),call(user:_18004),isInTimeInterval(_18014,_17992,_17998),!,_18078=..[_17956,_17992,_18014|_17976],retract(user:_18004),!,logDynamicEvent(_17962,retract,_18004),assertz(user:_18078),_17952='Prelude.True'.
prim_retractFact(_18244,'Prelude.False').
prim_getDynamicKnowledge(_18280):-reloadNewestDynamicVersions,dynamicTime(_18284),term2partcall('Dynamic.isKnownAtTime'(_18284),1,_18280),(compileWithSharing(function)->makeShare(_18280,_18306);_18306=_18280).
prim_isKnownAtTime(_18384,'Dynamic.Dynamic'(_18380),'Prelude.True'):-_18380=..[_18392,_18398,_18404,_18410|_18412],_18440=..[_18392,_18428,_18434|_18412],call(user:_18440),isInTimeInterval(_18384,_18428,_18434).
isInTimeInterval(_18532,_18534,_18536):-_18532>=_18534,(_18536=0->true;_18532=<_18536).
logDynamicEvent('Dynamic.Temporary',_18628,_18630):-!.
logDynamicEvent('Dynamic.Persistent',_18686,_18688):-_18688=..[_18692,_18698,_18704|_18706],_18734=..[_18692,0,0|_18706],_18752=..[_18686,_18734],user:dynamicPredInfo(_18692/_18760,_18766),logDynamic(_18752,_18766).
logDynamic(_18856,_18858):-dir2tmplockfile(_18858,_18864),lockWithFileIfNotInTransaction(_18864),executeWithFinalize((dir2logfile(_18858,_18874),open(_18874,append,_18882),writeq(_18882,_18856),put_code(_18882,46),nl(_18882),flush_output(_18882),close(_18882),addChangePid(_18858)),unlockWithFileIfNotInTransaction(_18864)).
executeWithFinalize(_19020,_19022):-on_exception(_19030,_19020,(call(_19022),printError(_19030),!,fail)),!,call(_19022).
executeWithFinalize(_19118,_19120):-call(_19120),!,fail.
prim_startTransaction(_19182):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_19244,initTransaction(_19182),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_19244),fail)),!.
initTransaction(_19326):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_19330)),_19326 is _19330+1,assertz(dynamicTime(_19326)),logAllDynamicPreds(startTransaction(_19326)).
prim_commitTransaction(_19430,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_19430)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_19514):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_19522),map1partialM(prim_dynamic:addChangePid(0),_19522),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_19628):-findall(_19632,isDynamicDir(_19632),_19640),sort(_19640,_19628).
isDynamicDir(_19690):-user:dynamicPredInfo(_19694,_19690),\+_19690=''.
logAllDynamicPreds(_19756):-getDynamicDirs(_19760),map1partialM(prim_dynamic:logDynamic(_19756),_19760).
initializeDynamic:-user:dynamicPredInfo(_19820/_19822,_19828),initializeDynamic(_19828,_19820/_19822),fail.
initializeDynamic.
initializeDynamic('',_19898/_19900):-!,retractAllFacts(_19898/_19900).
initializeDynamic(_19974,_19968/_19970):-existsDirectory(_19974),!,checkDynSpec(_19974,_19968/_19970),setDynamicVersion(_19974,_19968/_19970,0),!.
initializeDynamic(_20076,_20078):-existsFile(_20076),!,appendAtom('ERROR: Directory "',_20076,_20090),appendAtom(_20090,'" for dynamic entries cannot be created!',_20098),writeErr(_20098),nlErr,!,fail.
initializeDynamic(_20196,_20190/_20192):-upDirectory(_20196,_20204),(existsDirectory(_20204)->createDynamicDir(_20196,_20190/_20192),setDynamicVersion(_20196,_20190/_20192,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_20196),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_20382,_20384):-atom_codes(_20382,_20390),append(_20400,[47|_20396],_20390),\+member(47,_20396),!,atom_codes(_20384,_20400).
upDirectory(_20490,'.').
checkDynSpec(_20532,_20526/_20528):-dir2specfile(_20532,_20540),existsFile(_20540),readPrologTermFile(_20540,_20550),dynamicSpec(_20526/_20528,_20550),!.
checkDynSpec(_20632,_20634):-appendAtom('ERROR: Directory "',_20632,_20642),appendAtom(_20642,'" contains no matching dynamic entries!',_20650),writeErr(_20650),nlErr,!,fail.
replayLogFile(_20736,_20730/_20732):-dir2tmplockfile(_20736,_20744),lockWithFileIfNotInTransaction(_20744),executeWithFinalize(replayLogFileWhenAlreadyLocked(_20736,_20730/_20732),unlockWithFileIfNotInTransaction(_20744)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_20852,_20846/_20848):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_20852),writeErr('\'...'),nlErr;true),getRunTime(_20906),ensurePakcsVersion(_20852),dir2dbfile(_20852,_20916),dir2pofile(_20852,_20922),consultPrologorPOFile(_20916,_20922),dir2logfile(_20852,_20934),open(_20934,read,_20942),(atEndOfStream(_20942)->close(_20942);assert(replayStatus(unchanged)),repeat,on_exception(_20972,readAndReplay(_20942),((printError(_20972)->true;true),writeErr('ERROR during reading of '),writeErr(_20934),writeErr(' (restored state might be incomplete)'),nlErr)),close(_20942),retract(replayStatus(_21036)),writeNewDatabaseIfChanged(_20846/_20848,_20852,_21036)),updateDynFactsIfNecessary(_20852,_20846/_20848),readDynamicVersion(_20852,_21108),setDynamicVersion(_20852,_20846/_20848,_21108),writeChangePids(_20852,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_21142),_21152 is _21142-_20906,writeErr(_21152),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_21334):-readPAKCSVersion(_21334,_21340),_21340=pakcsVersion(_21344,_21346),prologMajor(_21356),\+_21356=_21346,dir2pofile(_21334,_21372),(existsFile(_21372)->deleteFile(_21372);true),writePAKCSVersion(_21334),!.
ensurePakcsVersion(_21476).
isCurrentPakcsVersion(_21502):-readPAKCSVersion(_21502,_21508),compilerVersion(_21512),!,(_21508=compilerVersion(_21512)->writePAKCSVersion(_21502);_21508=pakcsVersion(_21512,_21538)).
readPAKCSVersion(_21606,_21608):-dir2pakcsversionfile(_21606,_21614),existsFile(_21614),readPrologTermFile(_21614,_21608).
writePAKCSVersion(_21682):-dir2pakcsversionfile(_21682,_21688),compilerVersion(_21692),prologMajor(_21696),writePrologTermFile(_21688,pakcsVersion(_21692,_21696)).
updateDynFactsIfNecessary(_21764,_21766):-isCurrentPakcsVersion(_21764),!.
updateDynFactsIfNecessary(_21828,_21822/_21824):-compilerVersion(_21834),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_21828),writeErr('\' to compiler version '),writeErr(_21834),writeErr(...),nlErr;true),updateDynFacts(_21822/_21824),writeNewDatabaseIfChanged(_21822/_21824,_21828,changed),writePAKCSVersion(_21828).
updateDynFactsIfNecessary(_22000,_22002).
updateDynFacts(_22036/_22038):-functor(_22046,_22036,_22038),functor(_22054,_22036,_22038),retract(user:_22046),arg(1,_22046,_22076),arg(1,_22054,_22076),arg(2,_22046,_22092),arg(2,_22054,_22092),translateDynFactArgs(3,_22038,_22046,_22054),asserta(user:_22054),fail.
updateDynFacts(_22212).
translateDynFactArgs(_22238,_22240,_22242,_22244):-_22238>_22240,!.
translateDynFactArgs(_22318,_22320,_22322,_22324):-arg(_22318,_22322,_22332),translateDynFactArg(_22332,_22338),arg(_22318,_22324,_22338),_22356 is _22318+1,translateDynFactArgs(_22356,_22320,_22322,_22324).
translateDynFactArg(_22454,_22454):-var(_22454),!.
translateDynFactArg(_22512,_22512):-number(_22512),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_23050,_23052):-atomic(_23050),atom_codes(_23050,[40|_23062]),!,appendAtom('Prelude.',_23050,_23052).
translateDynFactArg(_23140,_23142):-atom(_23140),atom_codes(_23140,[39|_23152]),!,(_23152=[_23162]->char_int(_23142,_23162);_23152=[78,85,76]->char_int(_23142,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_23304,_23304):-atomic(_23304),!.
translateDynFactArg(_23362,_23364):-functor(_23362,_23370,_23372),translateDynFactArg(_23370,_23378),functor(_23364,_23378,_23372),translateDynFactArgs(1,_23372,_23362,_23364).
writeNewDatabaseIfChanged(_23460/_23462,_23468,changed):-!,dir2dbfile(_23468,_23476),dir2pofile(_23468,_23482),dir2logfile(_23468,_23488),appendAtom(_23476,'.bak',_23496),tell(_23496),writeq((:-dynamic _23460/_23462)),put_code(46),nl,listing(user:_23460/_23462),told,try_save_predicates(_23460/_23462,_23482),renameFile(_23496,_23476),appendAtom(_23488,'.bak',_23564),renameFile(_23488,_23564),appendAtom('touch ',_23488,_23578),shellCmd(_23578),readDynamicVersion(_23468,_23588),_23598 is _23588+1,writeDynamicVersion(_23468,_23598),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_23808/_23810,_23816,_23818):-dir2logfile(_23816,_23824),appendAtom(_23824,'.bak',_23832),renameFile(_23824,_23832),appendAtom('touch ',_23824,_23846),shellCmd(_23846).
readAndReplay(_23928):-atEndOfStream(_23928),!.
readAndReplay(_23976):-read(_23976,_23982),replayEvent(_23976,_23982).
replayEvent(_24032,end_of_file):-!.
replayEvent(_24084,startTransaction(_24080)):-readAndReplayTransaction(_24084,_24080,[]),!,fail.
replayEvent(_24152,_24154):-retract(replayStatus(_24158)),assert(replayStatus(changed)),call(user:_24154),!,fail.
readAndReplayTransaction(_24250,_24252,_24254):-atEndOfStream(_24250),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_24252),nlErr;true).
readAndReplayTransaction(_24362,_24364,_24366):-read(_24362,_24372),(_24372=commitTransaction(_24364)->callRevList(_24366);_24372=abortTransaction->true;readAndReplayTransaction(_24362,_24364,[_24372|_24366])),!.
callRevList([]).
callRevList([_24522|_24524]):-callRevList(_24524),retract(replayStatus(_24536)),assert(replayStatus(changed)),call(user:_24522).
startTransaction(_24614).
commitTransaction(_24640).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_24678),map1M(prim_dynamic:lockDynamicDir,_24678).
lockDynamicDir(_24724):-dir2lockfile(_24724,_24730),lockWithFile(_24730).
lockWithFileIfNotInTransaction(_24778):-insideTransaction->true;lockWithFile(_24778).
lockWithFile(_24832):-appendAtom('lockfile-create --lock-name ',_24832,_24840),(existsFile(_24832),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_24832),writeErr('\'...'),nlErr;true),shellCmd(_24840),!.
unlockAllPersistentDynamics:-getDynamicDirs(_24958),map1M(prim_dynamic:unlockDynamicDir,_24958).
unlockDynamicDir(_25004):-dir2lockfile(_25004,_25010),unlockWithFile(_25010).
unlockWithFileIfNotInTransaction(_25058):-insideTransaction->true;unlockWithFile(_25058).
unlockWithFile(_25112):-existsFile(_25112),!,appendAtom('lockfile-remove --lock-name ',_25112,_25124),shellCmd(_25124).
unlockWithFile(_25184).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_25210/_25212,_25218),dynamicVersion(_25218,_25210/_25212,_25238),reloadNewestDynamicVersion(_25218,_25210/_25212,_25238),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_25310):-dynamicVersion(_25320,_25310/_25316,_25324),!,reloadNewestDynamicVersion(_25320,_25310/_25316,_25324).
reloadNewestDynamicVersionOf(_25388).
reloadNewestDynamicVersion(_25420,_25414/_25416,0):-!,retractAllFacts(_25414/_25416),replayLogFile(_25420,_25414/_25416),!.
reloadNewestDynamicVersion(_25524,_25518/_25520,_25528):-readDynamicVersion(_25524,_25534),\+_25528=_25534,!,retractAllFacts(_25518/_25520),replayLogFile(_25524,_25518/_25520),!.
reloadNewestDynamicVersion(_25650,_25652,_25654):-readChangePids(_25650,_25660),currentPID(_25664),(_25660=[];_25660=[_25664]),!.
reloadNewestDynamicVersion(_25766,_25760/_25762,_25770):-retractAllFacts(_25760/_25762),replayLogFile(_25766,_25760/_25762).
createDynamicDir(_25858,_25852/_25854):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_25858),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_25858,_25916),shellCmd(_25916),dir2logfile(_25858,_25926),appendAtom('touch ',_25926,_25934),shellCmd(_25934),dir2dbfile(_25858,_25944),appendAtom('touch ',_25944,_25952),shellCmd(_25952),dir2specfile(_25858,_25962),dynamicSpec(_25852/_25854,_25974),writePrologTermFile(_25962,_25974),writePAKCSVersion(_25858).
readPrologTermFile(_26102,_26104):-open(_26102,read,_26112),read(_26112,_26104),close(_26112).
writePrologTermFile(_26180,_26182):-open(_26180,write,_26190),writeq(_26190,_26182),put_code(_26190,46),nl(_26190),flush_output(_26190),close(_26190).
readDynamicVersion(_26290,_26292):-dir2versionfile(_26290,_26298),existsFile(_26298),!,on_exception(_26318,readPrologTermFile(_26298,_26292),_26292=0).
readDynamicVersion(_26386,1).
writeDynamicVersion(_26422,_26424):-dir2versionfile(_26422,_26430),writePrologTermFile(_26430,_26424).
readChangePids(_26488,_26490):-dir2changepidsfile(_26488,_26496),existsFile(_26496),!,on_exception(_26522,readPrologTermFile(_26496,_26490),_26490=[0]).
readChangePids(_26590,[]).
writeChangePids(_26626,_26628):-dir2changepidsfile(_26626,_26634),writePrologTermFile(_26634,_26628).
addChangePid(_26692):-currentPID(_26696),addChangePid(_26696,_26692).
addChangePid(_26746,_26748):-readChangePids(_26748,_26754),(member(_26746,_26754)->true;writeChangePids(_26748,[_26746|_26754])),!.
dynamicSpec(_26842/_26844,dynamicPredicate(_26842,_26844)).
retractDeadDynamicFacts(_26890/_26892):-length(_26900,_26892),_26912=..[_26890|_26900],_26900=[_26918,_26924|_26926],dynamicTime(_26936),call(user:_26912),_26924>0,_26936>_26924,retract(user:_26912),fail.
retractDeadDynamicFacts(_27054).
dir2logfile(_27080,_27082):-appendAtom(_27080,'/eventlog',_27082).
dir2lockfile(_27136,_27138):-appendAtom(_27136,'/LOCK',_27138).
dir2tmplockfile(_27192,_27194):-appendAtom(_27192,'/LOCK',_27194).
dir2dbfile(_27248,_27250):-appendAtom(_27248,'/database.pl',_27250).
dir2pofile(_27304,_27306):-appendAtom(_27304,'/dbpred.po',_27306).
dir2specfile(_27360,_27362):-appendAtom(_27360,'/spec',_27362).
dir2pakcsversionfile(_27416,_27418):-appendAtom(_27416,'/pakcsversion',_27418).
dir2versionfile(_27472,_27474):-appendAtom(_27472,'/version',_27474).
dir2changepidsfile(_27528,_27530):-appendAtom(_27528,'/changepids',_27530).
