:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_17618):-(getEnv('PAKCS_LOCALHOST',_17624)->true;_17624=no),(_17624=yes->asserta(only_localhost(yes)),_17618=yes;asserta(only_localhost(no)),_17618=no),retract((only_localhost(_17704):-_17708,_17710)),!.
tracePorts(unknown).
ifTracePort(_17802):-tracePorts(_17806),(_17806=unknown->retract(tracePorts(_17816)),(getEnv('PAKCS_TRACEPORTS',_17826)->true;_17826=no),(_17826=yes->asserta(tracePorts(yes)),_17802;asserta(tracePorts(no)));_17806=yes->_17802;true).
prim_openPort(_17970,_17972,_17974):-nonvar(_17970),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_18060,_18062,_18064):-nonvar(_18062),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_18156),_18156,'Prelude.True').
prim_openPortOnSocket(_18206,_18208,_18210):-(retract(mySocket('Ports.internalPort'(_18214,_18216,_18218,_18220)))->_18238 is _18218+1,asserta(mySocket('Ports.internalPort'(_18214,_18216,_18238,_18220))),(_18206=_18216,_18208=_18238->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_18206),on_exception(_18344,listenOnNewSocket(_18206,_18326,_18220),(write('ERROR: openPortOnSocket "'),write(_18206),write('":'),nl,printError(_18344),!,fail)),atom2String(_18326,_18214),(var(_18208)->_18208=0;true),asserta(mySocket('Ports.internalPort'(_18214,_18206,_18208,_18220)))),mySocket(_18468),_18468='Ports.internalPort'(_18472,_18474,_18476,_18478),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_18476),writeErr(' at socket '),writeErr(_18474),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_18472,_18524),writeErr(_18524)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_18468),_18210);_18210='Ports.basicServerLoop'(_18468)).
trySetSocketNumber(_18704):-var(_18704),getEnv('PAKCS_SOCKET',_18714),atom_codes(_18714,_18720),number_codes(_18704,_18720),!.
trySetSocketNumber(_18788).
prim_basicServerLoop(_19092,_19094,_19096,_19098):-freeze(_19096,blocked_prim_basicServerLoop(_19092,_19094,_19096,_19098)).
blocked_prim_basicServerLoop(_19160,_19162,_19164,_19166):-readPort(_19160,_19172,-1),_19162=[_19172|_19180],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_19160),_19180);_19180='Ports.basicServerLoop'(_19160)),_19164=_19166.
prim_timeoutOnStream(_19588,_19590,_19592,_19594,_19596):-freeze(_19594,blocked_prim_timeoutOnStream(_19588,_19590,_19592,_19594,_19596)).
blocked_prim_timeoutOnStream(_19666,_19668,_19670,_19672,_19674):-user:derefRoot(_19666,_19680),prim_timeoutOnStream_exec(_19680,_19668,_19670,_19672,_19674).
prim_timeoutOnStream_exec(_19774,_19776,'Prelude.Nothing',_19780,_19782):-var(_19776),!,_19780=_19782.
prim_timeoutOnStream_exec(_19878,share(_19874),_19882,_19884,_19886):-!,get_mutable(_19890,_19874),(_19890='$eval'(_19896)->_19882=_19896,_19884=_19886;prim_timeoutOnStream_exec(_19878,_19890,_19934,_19884,_19886),(_19934='Prelude.Nothing'->_19882=_19934;(compileWithSharing(variable)->user:propagateShare(_19934,_19882);_19934=_19882),update_mutable('$eval'(_19882),_19874))).
prim_timeoutOnStream_exec(_20110,[],'Prelude.Just'([]),_20116,_20118):-!,_20116=_20118.
prim_timeoutOnStream_exec(_20216,[_20200|_20202],'Prelude.Just'([_20200|_20202]),_20222,_20224):-!,_20222=_20224.
prim_timeoutOnStream_exec(_20310,'Ports.basicServerLoop'(_20306),_20314,_20316,_20318):-(readPort(_20306,_20324,_20310)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_20306),_20340);_20340='Ports.basicServerLoop'(_20306)),_20314='Prelude.Just'([_20324|_20340]);_20314='Prelude.Nothing'),_20316=_20318.
send_extvar_binding(_20756,_20758,_20760,_20762):-freeze(_20758,blocked_send_extvar_binding(_20756,_20758,_20760,_20762)).
blocked_send_extvar_binding(_20824,_20826,_20828,_20830):-evalToken(_20834),user:normalizeAndCheck(_20826,_20840,_20834,_20844),user:waitUntilGround(_20840,_20844,_20858),eval_send_extvar_binding(_20824,_20840,_20828,_20858,_20830).
eval_send_extvar_binding(_21260,_21262,_21264,_21266,_21268):-freeze(_21266,blocked_eval_send_extvar_binding(_21260,_21262,_21264,_21266,_21268)).
blocked_eval_send_extvar_binding(nostream,_21340,_21342,_21344,_21346):-writeErr('ERROR: cannot send binding for variable '),writeErr(_21342),writeErr(': '),writeErr(_21340),nlErr,!.
blocked_eval_send_extvar_binding(_21462,_21464,_21466,_21468,_21470):-show4sending(_21464,_21476,_21478),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_21466),writeErr(': '),writeChars(user_error,_21476),nlErr)),number_codes(_21466,_21530),putChars(_21462,[86|_21530]),put_code(_21462,10),writeChars(_21462,_21476),put_code(_21462,10),flush_output(_21462),!,_21470=done.
readPort('Ports.internalPort'(_21694,_21696,_21698,_21700),_21706,_21708):-var(_21700),!,string2Atom(_21694,_21718),writeErr('ERROR: readPort: Port '),writeErr(_21696),writeErr(/),writeErr(_21698),writeErr(@),writeErr(_21718),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_21860,_21862,_21864,_21866),_21872,_21874):-on_exception(_21888,readFromSocket(_21864,_21866,_21872,_21874),(printError(_21888)->_21872=[];_21872=[])),!.
checkIncomingPortStreams(_21980,_21982,_21984):-retract(incomingPortStreams(_21980,[message(_21982,_21984)|_21996])),asserta(incomingPortStreams(_21980,_21996)),!.
checkIncomingPortStreams(_22082,_22084,_22086):-retract(incomingPortStreams(_22082,[ping(_22090,_22092)|_22098])),asserta(incomingPortStreams(_22082,_22098)),answerPingOnStream(_22090,_22092),checkIncomingPortStreams(_22082,_22084,_22086),!.
answerPingOnStream(_22210,_22212):-write(_22212,ok),put_code(_22212,10),flush_output(_22212),closeSocketStream(_22210,_22212),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_22318,_22320,_22322,_22324):-checkIncomingPortStreams(_22318,_22330,_22332),!,readStreamLine(_22330,_22338),(parse_received_message(_22330,_22332,_22338,_22322)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_22338),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_22338),nlErr,readFromSocket(_22318,_22320,_22322,_22324)),!.
readFromSocket(_22510,_22512,_22514,_22516):-waitForSocketClientStream(_22512,_22516,_22524,_22526,_22528),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_22524),nlErr)),(readPortMessage(_22510,_22526,_22528,_22562)->(parse_received_message(_22526,_22528,_22562,_22514)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_22562),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_22562),nlErr,readFromSocket(_22510,_22512,_22514,_22516));readFromSocket(_22510,_22512,_22514,_22516)),!.
readFromSocket(_22750,_22752,_22754,_22756):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_22838,_22840,_22842,_22844):-readStreamLine(_22840,_22850),_22850=[_22854|_22856],checkMessageHeader(_22854,_22840,_22842,_22872),number_codes(_22876,_22856),!,(_22876=_22838->readPortMessageBody(_22872,_22844);(retract(incomingPortStreams(_22876,_22902))->append(_22902,[_22872],_22920);_22920=[_22872]),asserta(incomingPortStreams(_22876,_22920)),!,fail).
checkMessageHeader(78,_23070,_23072,message(_23070,_23072)):-!.
checkMessageHeader(80,_23144,_23146,ping(_23144,_23146)):-!.
checkMessageHeader(_23218,_23220,_23222,_23224):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_23308,_23310),_23316):-readStreamLine(_23308,_23316).
readPortMessageBody(ping(_23368,_23370),_23376):-answerPingOnStream(_23368,_23370),!,fail.
prim_sendPort(_23678,_23680,_23682,_23684,_23686):-freeze(_23684,blocked_prim_sendPort(_23678,_23680,_23682,_23684,_23686)).
blocked_prim_sendPort(_23756,_23758,_23760,_23762,_23764):-user:derefAll(_23756,_23770),user:derefRoot(_23758,_23782),prim_sendPortExec(_23770,_23782,_23760,_23762,_23764).
prim_sendPortExec(_23892,'Ports.internalPort'(_23882,0,_23886,_23888),'Prelude.True',_23898,_23900):-!,add2Stream(_23888,_23892),_23898=_23900.
prim_sendPortExec('Ports.SP_Put'(_23994),'Ports.internalPort'(_23998,-1,_24002,_24004),'Prelude.True',_24014,_24016):-!,user:waitUntilGround(_23994,_24014,_24016),writeChars(_24004,_23994),nl(_24004),flush_output(_24004),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_23994),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_24170),'Ports.internalPort'(_24174,-1,_24178,_24180),'Prelude.True',_24190,_24192):-!,readStreamLine(_24174,_24198),map2M(basics:char_int,_24210,_24198),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_24210),nlErr)),user:constrEq(_24210,_24170,_24246,_24190,_24192).
prim_sendPortExec('Ports.SP_GetChar'(_24350),'Ports.internalPort'(_24354,-1,_24358,_24360),'Prelude.True',_24370,_24372):-!,get_code(_24354,_24378),char_int(_24378,_24384),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_24384),nlErr)),user:constrEq(_24384,_24350,_24416,_24370,_24372).
prim_sendPortExec('Ports.SP_EOF'(_24520),'Ports.internalPort'(_24524,-1,_24528,_24530),'Prelude.True',_24540,_24542):-!,(atEndOfStream(_24524)->_24550='Prelude.True';_24550='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_24550),nlErr)),user:constrEq(_24520,_24550,_24602,_24540,_24542).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_24700,-1,_24704,_24706),'Prelude.True',_24716,_24718):-!,close(_24706),close(_24700),_24716=_24718.
prim_sendPortExec(_24830,'Ports.internalPort'(_24820,-1,_24824,_24826),'Prelude.True',_24836,_24838):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_24830),nlErr,_24836=_24838.
prim_sendPortExec(_24956,'Ports.internalPort'(_24946,_24948,_24950,_24952),'Prelude.True',_24962,_24964):-string2Atom(_24946,_24970),on_exception(_25004,send2Socket(_24970,_24948,_24950,_24956),(write('ERROR: send to port '),write(_24950),write(@),write(_24970),write(:),nl,(printError(_25004)->true;true))),_24962=_24964.
add2Stream(_25148,_25150):-var(_25148),!,_25148=[_25150|_25160].
add2Stream([],_25226):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_25282|_25284],_25290):-add2Stream(_25284,_25290).
prim_ping(_25356,'Ports.internalPort'(_25342,0,_25346,_25348),'Prelude.Just'(0)):-!.
prim_ping(_25428,'Ports.internalPort'(_25414,-1,_25418,_25420),'Prelude.Just'(0)):-!.
prim_ping(_25496,'Ports.internalPort'(_25486,_25488,_25490,_25492),_25500):-string2Atom(_25486,_25506),on_exception(_25528,ping2SocketPort(_25506,_25488,_25490,_25496,_25500),_25500='Prelude.Nothing').
ping2SocketPort(_25592,_25594,_25596,_25598,_25600):-connect2socket(_25592,_25594,_25608,_25610),number_codes(_25596,_25616),putChars(_25610,[80|_25616]),put_code(_25610,10),flush_output(_25610),getElapsedTime(_25642),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_25594),writeErr(/),writeErr(_25596),writeErr(@),writeErr(_25592),writeErr('"'),nlErr)),waitForInputDataOnStreams([_25608],_25598,_25730),(_25730=0->readStreamLine(_25608,_25742),closeSocketStream(_25608,_25610),getElapsedTime(_25752),_25762 is _25752-_25642,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_25762),writeErr(' ms'),nlErr)),_25600='Prelude.Just'(_25762);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_25600='Prelude.Nothing').
prim_connectPortAtSocket(_26004,_26006,_26008,'Ports.internalPort'(_25994,_25996,_25998,'Prelude.()')):-user:derefRoot(_26004,_25996),user:derefRoot(_26006,_25998),user:derefAll(_26008,_25994),!.
send2Socket(_26126,_26128,_26130,_26132):-connect2socket(_26126,_26128,_26140,_26142),number_codes(_26130,_26148),putChars(_26142,[78|_26148]),put_code(_26142,10),show4sending(_26132,_26172,_26174),writeChars(_26142,_26172),put_code(_26142,10),flush_output(_26142),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_26128),writeErr(/),writeErr(_26130),writeErr(@),writeErr(_26126),writeErr('": '),writeChars(user_error,_26172),nlErr)),rev(_26174,_26282),receive_extvar_bindings(_26140,_26282).
receive_extvar_bindings(_26410,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_26410).
receive_extvar_bindings(_26488,_26490):-readStreamLine(_26488,_26496),_26496=[86|_26502],number_codes(_26512,_26502),readStreamLine(_26488,_26520),(deleteIndexVariable(_26512,_26490,_26528,_26530)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_26530=_26490),(parse_received_message(nostream,nostream,_26520,_26574)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_26512),writeErr(': '),putChars(user_error,_26520),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_26520),nlErr),!,_26528=_26574,receive_extvar_bindings(_26488,_26530).
show4sending(_26760,_26762,_26764):-numberVars(_26760,_26770,[],_26764),show_term(_26770,qualified,_26762,[]).
getVariableIndex(_26856,[(_26844,_26846)|_26852],_26846):-_26856==_26844,!.
getVariableIndex(_26932,[_26926|_26928],_26936):-getVariableIndex(_26932,_26928,_26936).
getIndexVariable(_27000,[(_26998,_27000)|_27006],_26998):-!.
getIndexVariable(_27074,[_27068|_27070],_27078):-getIndexVariable(_27074,_27070,_27078).
deleteIndexVariable(_27142,[(_27140,_27142)|_27148],_27140,_27148):-!.
deleteIndexVariable(_27232,[_27220|_27222],_27236,[_27220|_27228]):-deleteIndexVariable(_27232,_27222,_27236,_27228).
parse_received_message(_27310,_27312,_27314,_27316):-readTerm(_27314,qualified,_27324,_27326),skipWhiteSpace(_27324,[]),extractVars(_27326,_27316,[],_27342),send_extvar_bindings(_27342,_27348,_27312),closeStreamAfterDones(_27348,_27310,_27312).
send_extvar_bindings([],[],_27448).
send_extvar_bindings([(_27490,_27492)|_27498],[_27502|_27504],_27512):-send_extvar_binding(_27512,_27490,_27492,_27502),send_extvar_bindings(_27498,_27504,_27512).
closeStreamAfterDones([],nostream,_27594):-!.
closeStreamAfterDones([],_27650,_27652):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_27650,_27652).
closeStreamAfterDones([_27732|_27734],_27740,_27742):-closeStreamAfterDones(_27732,_27734,_27740,_27742).
closeStreamAfterDones(_28090,_28092,_28094,_28096):-freeze(_28090,blocked_closeStreamAfterDones(_28090,_28092,_28094,_28096)).
blocked_closeStreamAfterDones(_28158,_28160,_28162,_28164):-closeStreamAfterDones(_28160,_28162,_28164).
prim_openProcessPort(_28244,'Ports.internalPort'(_28234,-1,0,_28240)):-user:derefAll(_28244,_28252),string2Atom(_28252,_28264),execCommand(_28264,_28240,_28234,_28274).
prim_choiceSPEP(_28624,_28626,_28628,_28630,_28632):-freeze(_28626,freeze(_28630,blocked_prim_choiceSPEP(_28624,_28626,_28628,_28630,_28632))).
blocked_prim_choiceSPEP(_28708,_28710,_28712,_28714,_28716):-user:derefRoot(_28708,_28722),prim_choiceSPEP_exec(_28722,_28710,_28712,_28714,_28716).
prim_choiceSPEP_exec(_28820,share(_28816),_28824,_28826,_28828):-!,get_mutable(_28832,_28816),(_28832='$eval'(_28838)->_28826=_28828,_28824='Prelude.Right'(_28838);prim_choiceSPEP_exec(_28820,_28832,_28880,_28826,_28828),(_28880='Prelude.Left'(_28888)->_28824=_28880;_28880='Prelude.Right'(_28910),(compileWithSharing(variable)->user:propagateShare(_28910,_28926);_28910=_28926),_28824='Prelude.Right'(_28926),update_mutable('$eval'(_28926),_28816))).
prim_choiceSPEP_exec(_29104,[_29088|_29090],'Prelude.Right'([_29088|_29090]),_29110,_29112):-!,_29110=_29112.
prim_choiceSPEP_exec('Ports.internalPort'(_29194,-1,_29198,_29200),[],_29208,_29210,_29212):-readStreamLine(_29194,_29218),map2M(basics:char_int,_29230,_29218),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_29230),nlErr)),_29208='Prelude.Left'(_29230),_29210=_29212,!.
prim_choiceSPEP_exec(_29378,'Ports.basicServerLoop'(_29374),_29382,_29384,_29386):-_29374='Ports.internalPort'(_29390,_29392,_29394,_29396),checkIncomingPortStreams(_29394,_29408,_29410),!,readStreamLine(_29408,_29416),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_29374),_29430);_29430='Ports.basicServerLoop'(_29374)),(parse_received_message(_29408,_29410,_29416,_29462)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_29462),nlErr)),_29382='Prelude.Right'([_29462|_29430]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_29416),nlErr,prim_choiceSPEP_exec(_29378,_29430,_29382,_29384,_29386)),_29384=_29386,!.
prim_choiceSPEP_exec('Ports.internalPort'(_29678,-1,_29682,_29684),'Ports.basicServerLoop'(_29688),_29696,_29698,_29700):-_29688='Ports.internalPort'(_29704,_29706,_29708,_29710),waitForSocketOrInputStreams(_29710,_29728,_29730,_29732,[_29678],_29736),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_29688),_29750);_29750='Ports.basicServerLoop'(_29688)),(_29728=no->readStreamLine(_29678,_29784),map2M(basics:char_int,_29796,_29784),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_29796),nlErr)),_29696='Prelude.Left'(_29796);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_29728),nlErr)),(readPortMessage(_29708,_29730,_29732,_29892)->(parse_received_message(_29730,_29732,_29892,_29902)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_29902),nlErr)),_29696='Prelude.Right'([_29902|_29750]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_29892),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_29678,-1,_29972,_29684),_29750,_29696,_29698,_29700));prim_choiceSPEP_exec('Ports.internalPort'(_29678,-1,_30024,_29684),_29750,_29696,_29698,_29700))),_29698=_29700,!.
numberVars(_30166,'VAR'(_30162),_30170,_30172):-var(_30166),!,(getVariableIndex(_30166,_30170,_30162)->_30172=_30170;length(_30170,_30162),_30172=[(_30166,_30162)|_30170]).
numberVars(_30306,_30308,_30310,_30312):-isShowableArg(_30306),_30306=..[_30320|_30322],numberVarsList(_30322,_30334,_30310,_30312),_30308=..[_30320|_30334].
numberVarsList([],[],_30434,_30434).
numberVarsList([_30486|_30488],[_30492|_30494],_30502,_30504):-numberVars(_30486,_30492,_30502,_30514),numberVarsList(_30488,_30494,_30514,_30504).
extractVars(_30592,_30592,_30596,_30596):-var(_30592),!.
extractVars('VAR'(_30670),_30676,_30678,_30680):-!,(getIndexVariable(_30670,_30678,_30676)->_30680=_30678;_30680=[(_30676,_30670)|_30678]).
extractVars(_30792,_30794,_30796,_30798):-_30792=..[_30802|_30804],extractVarsList(_30804,_30816,_30796,_30798),_30794=..[_30802|_30816].
extractVarsList([],[],_30910,_30910).
extractVarsList([_30962|_30964],[_30968|_30970],_30978,_30980):-extractVars(_30962,_30968,_30978,_30990),extractVarsList(_30964,_30970,_30990,_30980).
prim_after(_31286,_31288,_31290,_31292):-freeze(_31290,blocked_prim_after(_31286,_31288,_31290,_31292)).
blocked_prim_after(_31354,_31356,_31358,_31358):-raise_exception('Ports.after not implemented!').
